;;; $Id: bexp.tst,v 1.3 2005/02/18 02:39:10 leavens Exp $

(require (lib "bexp.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (parse-bexp 'P) = (var-exp 'P) )
   ( (parse-bexp 'Q) = (var-exp 'Q) )
   ( (parse-bexp '(and (or P Q) P))
     = (and-exp (or-exp (var-exp 'P) (var-exp 'Q)) (var-exp 'P)) )
   ( (parse-bexp '(or (not P) Q))
     = (or-exp (not-exp (var-exp 'P)) (var-exp 'Q)) )

   ( (var-exp? (var-exp 'P)) ==> #t )
   ( (and-exp? (var-exp 'P)) ==> #f )
   ( (or-exp?  (var-exp 'P)) ==> #f )
   ( (not-exp? (var-exp 'P)) ==> #f )

   ( (var-exp? (and-exp (var-exp 'P) (var-exp 'Q))) ==> #f )
   ( (and-exp? (and-exp (var-exp 'P) (var-exp 'Q))) ==> #t )
   ( (or-exp?  (and-exp (var-exp 'P) (var-exp 'Q))) ==> #f )
   ( (not-exp? (and-exp (var-exp 'P) (var-exp 'Q))) ==> #f )

   ( (var-exp? (or-exp (var-exp 'P) (var-exp 'Q))) ==> #f )
   ( (and-exp? (or-exp (var-exp 'P) (var-exp 'Q))) ==> #f )
   ( (or-exp?  (or-exp (var-exp 'P) (var-exp 'Q))) ==> #t )
   ( (not-exp? (or-exp (var-exp 'P) (var-exp 'Q))) ==> #f )

   ( (var-exp? (not-exp (var-exp 'P))) ==> #f )
   ( (and-exp? (not-exp (var-exp 'P))) ==> #f )
   ( (or-exp?  (not-exp (var-exp 'P))) ==> #f )
   ( (not-exp? (not-exp (var-exp 'P))) ==> #t )

    )
 )
