;;; $Id: bintree.scm,v 1.1 2002/04/09 22:25:24 leavens Exp $

(deftype bintree? (type-predicate-for bintree))
(deftype leaf-node (-> (number) bintree))
(deftype interior-node (-> (symbol bintree bintree) bintree))

(define-datatype bintree bintree? 
  (leaf-node 
    (datum number?))
  (interior-node
    (key symbol?) 
    (left bintree?)
    (right bintree?)))
