;;; $Id: chez-init.scm,v 1.2 2005/02/17 16:29:22 leavens Exp $
;; compatibility file for chez scheme

;; save the nicer chez behavior
(define chez-printf printf)
(define chez-pretty-print pretty-print)

(load-quietly-from-lib "r5rs.scm")
 
;; use the nicer chez behavior for these
(set! sllgen:pretty-print chez-pretty-print)
(set! eopl:pretty-print chez-pretty-print)
(set! define-datatype:pretty-print chez-pretty-print)

;; make error stop invoke the debugger
(define eopl:error-stop break)

(load-quietly-from-lib "sllgen.scm")
(load-quietly-from-lib "define-datatype.scm")
(load-quietly-from-lib "test-harness.scm")
;(load "test-suite.scm")
