;;; $Id: copy.scm,v 1.1 2004/01/29 00:18:31 leavens Exp $
;;; AUTHOR: Brian Dorn and Gary T. Leavens

(deftype copy (forall (t) (-> ((list-of t)) (list-of t))))
(define copy
  (lambda (l)
    ;; ENSURES: Result is a copy of l
    (cond
     ((null? l) '())
     (else (cons (car l) (copy (cdr l)))))))
