;;; $Id: delete-even.scm,v 1.1 2004/01/29 04:53:50 leavens Exp $
;;; AUTHOR: Dalei Li and Gary T. Leavens

(deftype delete-even (-> ((list-of number)) (list-of number)))
(define delete-even
  (lambda (lon)
    ;; ENSURES: Result is like lon but without its even elements.
    (if (null? lon)
	'()
	(if (even? (car lon))
	    (delete-even (cdr lon))
	    (cons (car lon) (delete-even (cdr lon)))))))
