;;; $Id: environment.tst,v 1.1 2005/03/03 22:58:45 leavens Exp $

(run-regression-tests-equal?
 `(
    ( (apply-env (extend-env '(x y) '(3 4) (empty-env)) 'x) ==> 3 )
    ( (apply-env (extend-env '(x y) '(3 4) (empty-env)) 'y) ==> 4 )
    ( (apply-env (extend-env '(a b c x)
			     '(5 9 12 2)
			     (extend-env '(x y) '(3 4) (empty-env)))
		 'y) ==> 4 )
    ( (apply-env (extend-env '(a b c x)
			     '(5 9 12 2)
			     (extend-env '(x y) '(3 4) (empty-env)))
		 'x) ==> 2 )
    ( (apply-env (extend-env '(a b c x)
			     '(5 9 12 2)
			     (extend-env '(x y) '(3 4) (empty-env)))
		 'a) ==> 5 )
    ( (apply-env (extend-env '(a b c x)
			     '(5 9 12 2)
			     (extend-env '(x y) '(3 4) (empty-env)))
		 'b) ==> 9 )
    ( (apply-env (extend-env '(a b c x)
			     '(5 9 12 2)
			     (extend-env '(x y) '(3 4) (empty-env)))
		 'c) ==> 12 )
    ( (apply-env (extend-env '(a b c x)
			     '(5 9 12 2)
			     (extend-env
			      '() '()
			      (extend-env
			       '() '()
			       (extend-env '(x y) '(3 4) (empty-env)))))
		 'y) ==> 4 )
    )
 )

