;;; $Id: fix.scm,v 1.4 2002/04/09 22:25:24 leavens Exp $

;;; The following is quite useful for taking fixed points in Scheme,
;;; even though it's defined recursively, and so it's not a combinator.
;;; See the file y.scm for the usual fix-point combinators.
;;; Note that fix can handle multiple-argument functions.
(deftype fix
  (forall (S T) (-> ((-> ((-> (S ...) T)) (-> (S ...) T)))
		    (-> (S ...) T))))
(define fix
  (lambda (G)
    (lambda args
      (apply (G (fix G)) args))))

(define Y fix)
