;;; $Id: inject-extract.scm,v 1.6 2005/03/09 01:33:09 leavens Exp $

;;; Some helpers useful in making variant-record types (that type check)

(module inject-extract (lib "typedscm.ss" "lib342")
(provide inject extract-maker)
  
(deftype inject (forall (S T) (-> (S) T)))
(deftype extract-maker
  (forall (T)
    (-> (string) (-> ((-> (datum) boolean) string) (-> (datum) T)))))

(define inject
  (has-type-trusted
    (forall (S T) (-> (S) T))
    (lambda (x) x)))

(define extract-maker
  (has-type-trusted
    (forall (T)
      (-> (string) (-> ((-> (datum) boolean) string) (-> (datum) T))))
    (lambda (for)
      (lambda (test? name)
	(lambda (x)
	  (if (test? x)
	      x
	      (error
	       (string-append for "->" name " passed non-" name " argument:")
	       x)))))))
) ;; end module
