;;; $Id: iseq-map.tst,v 1.1 2005/02/06 06:39:55 leavens Exp $

(load "iseq-map.scm")

(define ones (iseq 1 (lambda () ones)))
(define twos (iseq 2 (lambda () twos)))

(run-regression-tests-equal?
 `(

   ( (iseq->head (iseq-map (lambda (e) (+ 1 e)) ones)) ==> 2 )
   ( (iseq->head (iseq->tail (iseq->tail
			      (iseq-map (lambda (e) (+ 1 e)) ones))))
     ==> 2 )
   ( (iseq->head (iseq->tail (iseq->tail
			      (iseq-map odd? twos))))
     ==> #f )
   ( (iseq->head (iseq->tail (iseq->tail
			      (iseq-map even? twos))))
     ==> #t )

    )
 )
