;;; $Id: iseq.scm,v 1.3 2005/02/17 16:29:22 leavens Exp $

;;; <iseq> ::= <number> <iseq>

(module iseq (lib "typedscm.ss" "lib342")

(provide iseq? iseq iseq->head iseq->tail)

(deftype iseq? (type-predicate-for iseq))

(deftype iseq (-> (number (-> () iseq)) iseq))

(deftype iseq->head (-> (iseq) number))
(deftype iseq->tail (-> (iseq) iseq))

(defrep (iseq (pair-of number (-> () iseq))))

(define iseq?
  (lambda (d)
    (and (pair? d)
	 (number? (car d))
	 (procedure? (cdr d)))))

(define iseq
  (lambda (num thunk)
    (cons num thunk)))

(define iseq->head
  car)

(define iseq->tail
  (lambda (iseq)
    ((has-type-trusted (-> () iseq) (cdr iseq)))))

) ; end module
