;;; $Id: iseq.tst,v 1.1 2005/02/06 06:39:55 leavens Exp $

(load "iseq.scm")

(define ones (iseq 1 (lambda () ones)))
(define twos (iseq 2 (lambda () twos)))

(run-regression-tests-equal?
 `(

   ( (iseq? ones) ==> #t )
   ( (iseq? twos) ==> #t )
   ( (iseq->head ones) ==> 1 )
   ( (iseq->head (iseq->tail ones)) ==> 1 )
   ( (iseq->head (iseq->tail (iseq->tail ones))) ==> 1 )
   ( (iseq->head twos) ==> 2 )
   ( (iseq->head (iseq->tail twos)) ==> 2 )
   ( (iseq->head (iseq->tail (iseq->tail twos))) ==> 2 )

    )
 )
