;; $Id: list-index.scm,v 1.12 2005/03/21 21:58:37 leavens Exp $

;; This module is obsolete, becuase its name is the same as a name it exports.
;; Use list-index-find instead.

(module list-index (lib "typedscm.ss" "lib342")

(provide list-index find)

(deftype find (forall (T) (-> (T (list-of T) number) number)))
(deftype list-index (forall (T) (-> (T (list-of T)) number)))

(define find
  (lambda (s los index)
    ; ENSURES: if s occurs in los, returns index plus the zero-based index
    ; of the first occurrence of s in los, otherwise returns -1
    (if (null? los) 
	-1
	(if (eq? s (car los)) 
	    index
	    (find s (cdr los) (+ 1 index))))))

(define list-index
  (lambda (s los)
    ; ENSURES: if s occurs in los, returns the zero-based index of
    ; the first occurrence of s in los, otherwise returns -1
    (find s los 0)))

) ;; end module
