;;; $Id: phone-number.tst,v 1.3 2005/02/18 02:39:10 leavens Exp $

(require (lib "phone-number.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (phone-number? (parse-phone-number '(555 . 1212))) ==> #t )
   ( (exchange? (parse-exchange 999)) ==> #t )
   ( (exchange? (parse-exchange 0)) ==> #t )
   ( (subscriber? (parse-subscriber 0)) ==> #t )
   ( (subscriber? (parse-subscriber 9999)) ==> #t )

   ( (exchange->number
      (phone-number->exchange (parse-phone-number '(555 . 1212))))
     ==> 555 )
   ( (subscriber->number
      (phone-number->subscriber (parse-phone-number '(555 . 1212))))
     ==> 1212 )

   ( (phone-number (exchange 555) (subscriber 1212))
     = (parse-phone-number '(555 . 1212)) )

   ( (phone-number->exchange (phone-number (exchange 0) (subscriber 9999)))
     = 0 )

   ( (phone-number->subscriber (phone-number (exchange 0) (subscriber 9999)))
     = 9999 )

   ( (exchange->number (exchange 555)) ==> 555 )
   ( (subscriber->number (subscriber 1234)) ==> 1234 )

    )
 )
