;;; $Id: procval-as-proc.scm,v 1.2 2005/02/16 11:20:05 leavens Exp $
;;; adapted from 3-5.scm

;;;;;;;;;;;;;;;; procedures ;;;;;;;;;;;;;;;;

(deftype procval? (type-predicate-for procval))
(deftype closure (-> ((list-of symbol) expression environment) procval))
(deftype apply-procval
  (-> (procval (list-of Expressed-Value)) Expressed-Value))

(define procval? procedure?)

(define closure
  (lambda (ids body env)
    (has-type-trusted
      procval
      (lambda (args)
        (eval-expression body (extend-env ids args env))))))

(define apply-procval
  (has-type-trusted
    (-> (procval (list-of Expressed-Value)) Expressed-Value)
    (lambda (proc args)
      (proc args))))
