;;; $Id: road-map.tst,v 1.4 2005/03/04 00:28:04 leavens Exp $

(run-regression-tests-equal?
 `(
    ( (roads-from (bare-earth) 'rome) = the-empty-set )
    ( (roads-from (bare-earth) 'anywhere) = the-empty-set )
    ( (roads-from (build-road 'rome 'venice (bare-earth))
		  'rome)
      = (set 'venice) )
    ( (roads-from (build-road 'rome 'venice (bare-earth))
		  'venice)
      = (set 'rome) )
    ( (roads-from (build-road 'rome 'venice (bare-earth))
		  'london)
      = (set ) )
    ( (set-equal? (roads-from (build-road 'rome 'venice
                                          (build-road 'rome 'lisbon
                                                      (bare-earth)))
                              'rome)
                  (set 'venice 'lisbon))
      ==> #t )
    ( (roads-from (build-road 'rome 'venice
			      (build-road 'rome 'lisbon
					  (bare-earth)))
		  'venice)
      = (set 'rome) )
    ( (roads-from (build-road 'rome 'venice
			      (build-road 'rome 'lisbon
					  (bare-earth)))
		  'lisbon)
      = (set 'rome) )
    ( (roads-from (build-road 'rome 'venice
			      (build-road 'rome 'lisbon
					  (bare-earth)))
		  'copenhagen)
      = (set ) )

    )
 )

