;;; $Id: scm-init.scm,v 1.3 2005/01/07 19:01:24 leavens Exp $
;;; EOPL2e compatibility file for SCM (tested with SCM version 5d3)

;;; save the nicer SCM behavior
(define scm-pretty-print pretty-print)

;;; The following make SCM R5RS compliant
(require 'values)
(require 'macro)
(require 'eval)
(set! *syntax-rules* #t)

(load "r5rs.scm")
 
;;; use the nicer SCM behavior for these
(set! sllgen:pretty-print scm-pretty-print)
(set! eopl:pretty-print scm-pretty-print)
(set! define-datatype:pretty-print scm-pretty-print)

;; make error stop actually stop
;(define eopl:error-stop abort)

(load "sllgen.scm")
(load "define-datatype.scm")
(load "test-harness.scm")
;(load "test-suite.scm")

