;;; $Id: standardize-chez.scm,v 1.9 2005/03/04 22:40:52 leavens Exp $

;;; Localize
(require (lib "localize.scm" "lib342"))

;; homework testing, displayln, writeln
(require (lib "test-homework.scm" "lib342"))

;;; Define displayln and writeln
;(require (lib "displayln.scm" "lib342"))
;(require (lib "writeln.scm" "lib342"))

(require (lib "load-from-lib.scm" "lib342"))

;;; Make Chez Scheme compatible with SLIB
(load-quietly-from-lib "chez.init")

;; ... and redefine require macro, again...
(load-quietly-from-lib "translate-module-syntax.scm")

;; Some other things to make chez more like SCM
(print-vector-length #f)

(define chez:error error)
(define abort reset)

(define error
  (lambda args
    (let ((port (current-error-port)))
      (display "ERROR:" port)
      (for-each (lambda (x) (display " " port) (display x port)) args)
      (newline port)
      (abort))))

(define quit exit)

(define promise? procedure?)

;; load the EOPL init file
(load-quietly-from-lib "chez-init.scm")

;; the type notation
(load-quietly-from-lib "tc-ignore-types-at-runtime-chez.scm")
