;;; $Id: temperature.tst,v 1.3 2005/02/18 02:39:11 leavens Exp $

(require (lib "temperature.scm" "lib342"))

(run-regression-tests-equal?
 `(

   ( (parse-temperature 'hot) = (hot) )
   ( (parse-temperature 'warm) = (warm) )
   ( (parse-temperature 'cold) = (cold) )

   ( (hot? (hot)) ==> #t )
   ( (warm? (warm)) ==> #t )
   ( (cold? (cold)) ==> #t )

   ( (hot? (warm)) ==> #f )
   ( (hot? (cold)) ==> #f )

   ( (warm? (hot)) ==> #f )
   ( (warm? (cold)) ==> #f )

   ( (cold? (hot)) ==> #f )
   ( (cold? (warm)) ==> #f )

    )
 )
