;;; $Id: ex3-7-expressed-value.scm,v 1.3 2005/03/07 00:48:04 leavens Exp $

;; upcasts
(deftype number->expressed (-> (number) Expressed-Value))
(deftype list->expressed (-> ((list-of Expressed-Value)) Expressed-Value))

;; downcasts
(deftype expressed->number (-> (Expressed-Value) number))
(deftype expressed->list (-> (Expressed-Value) (list-of Expressed-Value)))

(require (lib "inject-extract.scm" "lib342"))

; (defrep (Expressed-Value datum))

(define number->expressed
  inject)

(define list->expressed
  inject)

(define expressed-value:extract
  (extract-maker "expressed"))

(define expressed->number
  (expressed-value:extract number? "number"))

(define expressed->list
  (expressed-value:extract list? "list"))


