;;; $Id: mapcdr.scm,v 1.1 2004/01/29 04:53:50 leavens Exp $
;;; AUTHOR: Dalei Li and Gary T. Leavens

(deftype mapcdr
  (forall (t) (-> ((list-of (list-of t))) (list-of (list-of t)))))
(define mapcdr
  (lambda (lst)
    ;; ENSURES: Result is the list (map cdr lst)
    (if (null? lst)
	'()
	(cons (cdr (car lst)) (mapcdr (cdr lst))))))


