;;; $Id: matrix-ops.tst,v 1.3 2005/02/18 02:39:10 leavens Exp $

(require (lib "matrix-ops.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( (scalar-add 3 (parse-matrix '((1 2)
				    (3 4)
				    (5 6))))
      ==> ((4 5)
	   (6 7)
	   (8 9)) )
    ( (scalar-multiply 3 (parse-matrix '((1 2)
					 (3 4)
					 (5 6))))
      ==> ((3 6)
	   (9 12)
	   (15 18)) )
    ( (transpose (parse-matrix '((1 2)
				 (3 4)
				 (5 6))))
      ==> ((1 3 5) (2 4 6)) )
    )
 )

