;;; $Id: maybe.tst,v 1.3 2005/02/18 02:39:10 leavens Exp $

(require (lib "maybe.scm" "lib342"))

(run-regression-tests-equal?
 `(
    ( ((maybe-of number?) (make-something 3)) ==> #t )
    ( ((maybe-of number?) 3) ==> #f )
    ( (maybe-something? (make-something #f)) ==> #t )
    ( (maybe-nothing? (make-nothing)) ==> #t )
    ( (maybe-something? (make-nothing)) ==> #f )
    ( (maybe-nothing? (make-something #f)) ==> #f )
    ( (something->value (make-something 3)) ==> 3 )
    ( (something->value (make-something '(3 4 2))) ==> (3 4 2) )
    ( (maybe-test (make-something 342)
		  (lambda (v) v)
		  (lambda () -1))
      ==> 342 )
    ( (maybe-test (make-nothing)
		  (lambda (v) v)
		  (lambda () -1))
      ==> -1 )
    )
 )

