;;; $Id: negate-bexp.tst,v 1.1 2005/02/06 06:18:12 leavens Exp $

(load "negate-bexp.scm")

(run-regression-tests-equal?
 `(

     ( (negate-bexp (parse-bexp 'P))
       = (parse-bexp '(not P)) )
     ( (negate-bexp (parse-bexp 'Q))
       = (parse-bexp '(not Q)) )
     ( (negate-bexp (parse-bexp '(not P)))
       = (parse-bexp 'P) )
     ( (negate-bexp (parse-bexp '(or (not P) Q)))
       = (parse-bexp '(and P (not Q))) )
     ( (negate-bexp (parse-bexp '(and P (or Q (not Q)))))
       = (parse-bexp '(or (not P) (and (not Q) Q))) )
     ( (negate-bexp (parse-bexp '(and (or P P) (or (or P P) (or Q Q)))))
       = (parse-bexp '(or (and (not P) (not P)) (and (and (not P) (not P))
						     (and (not Q) (not Q))))) )
    )
 )
