;;; $Id: product.scm,v 1.2 2002/04/09 22:25:25 leavens Exp $

(deftype product (-> (number ...) number))
(define product
  (lambda args
    (product-from-list args)))

(deftype product-from-list (-> ((list-of number)) number))
(define product-from-list
  (lambda (prod-list)
    (if (null? prod-list)
	1
	(* (car prod-list)
	   (product-from-list (cdr prod-list))))))
