;;; $Id: remove-sym-exp.scm,v 1.4 2005/02/07 17:40:20 leavens Exp $

(load-quietly-from-lib "sym-exp.scm")

(deftype remove-sym-exp (-> (symbol sym-exp) (list-of sym-exp)))
(define remove-sym-exp
  (lambda (sym symexp)
    (if (sym-exp-symbol? symexp)
        (if (eq? sym (sym-exp->symbol symexp))
            '()
            (list symexp))
        (list (s-list
	       (remove-s-list sym (sym-exp->s-list symexp)))))))

(deftype remove-s-list (-> (symbol (list-of sym-exp)) (list-of sym-exp)))
(define remove-s-list
  (lambda (sym slst)
    (if (null? slst)
	'()
	(append (remove-sym-exp sym (car slst))
		(remove-s-list sym (cdr slst))))))

;; see also remove-sym-exp-with-map.scm

