;;; $Id: targets.tst,v 1.1 2005/02/10 22:48:45 leavens Exp $

(load "targets.scm")

(run-regression-tests-equal?
 `(

    ( (set-equal?
       (targets (parse-statement 'x))
       (set )) ==> #t )

    ( (set-equal?
       (targets (parse-statement '(set! x 3)))
       (set 'x)) ==> #t )

    ( (set-equal?
       (targets
	(parse-statement
         '(set! x (begin (set! y 4) y))))
       (set 'x 'y)) ==> #t )

    ( (set-equal?
       (targets
	(parse-statement
         '(set! x
		(begin
		  3
		  z
		  (set! q (begin (set! m 7) n))
		  (set! y 4)
		  y))))
       (set 'x 'y 'q 'm)) ==> #t )

    )
 )
