;;; $Id: tc-compute-global-var-types.scm,v 1.3 2005/03/11 22:31:37 leavens Exp $
;;; Types for built-in Scheme procedures
;;; AUTHORS: Curtis Clifton and Gary T. Leavens,
;;;          from an earlier verison by Steven L. Jenkins.

(require (lib "tc-env.scm" "lib342")
	 (lib "tc-global-var-output-types.scm"))
(load-quietly-from-lib "tc-compute-cxr-types.scm")

(deftype *tc:pre-global-var-types* (tc:env-of symbol tc:type-expr))
(define *tc:pre-global-var-types*
  (tc:env-map
    (lambda (sym output-typ)
      (tc:type-parse output-typ))
    (tc:env-join *tc:pre-global-var-output-type-env*
		 *tc:cxr-output-type-env*)))
