;;; $Id: tc-qq-depth-stack.scm,v 1.1 2005/02/28 06:58:05 leavens Exp $

(module tc-qq-depth-stack (lib "typedscm.ss" "lib342")

(provide tc:push-new-qq-depth-counter! tc:pop-qq-depth-stack!
	 tc:inc-top-of-qq-depth-stack! tc:dec-top-of-qq-depth-stack!
	 tc:top-of-qq-depth-stack)

(deftype tc:push-new-qq-depth-counter! (-> () void))
(deftype tc:pop-qq-depth-stack! (-> () void))
(deftype tc:inc-top-of-qq-depth-stack! (-> () void))
(deftype tc:dec-top-of-qq-depth-stack! (-> () void))
(deftype tc:top-of-qq-depth-stack (-> () number))

(deftype *tc:qq-depth-stack* (list-of number))
(define *tc:qq-depth-stack* '())

(define tc:push-new-qq-depth-counter!
  (lambda ()
    (set! *tc:qq-depth-stack* (cons 1 *tc:qq-depth-stack*))))
(define tc:pop-qq-depth-stack!
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (set! *tc:qq-depth-stack* (cdr *tc:qq-depth-stack*))))
(define tc:inc-top-of-qq-depth-stack!
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (set! *tc:qq-depth-stack* (cons (+ (car *tc:qq-depth-stack*) 1)
				    (cdr *tc:qq-depth-stack*)))))
(define tc:dec-top-of-qq-depth-stack!
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (set! *tc:qq-depth-stack* (cons (- (car *tc:qq-depth-stack*) 1)
				    (cdr *tc:qq-depth-stack*)))))
(define tc:top-of-qq-depth-stack
  (lambda ()
    ;; REQUIRES: *tc:qq-depth-stack* is not null
    (car *tc:qq-depth-stack*)))
)
