;;; $Id: unary-notation.scm,v 1.1 2004/02/10 04:54:14 leavens Exp $
;;; AUTHOR: Tongjie Chen and Gary T. Leavens

(load-quietly-from-lib "sub1.scm")

(deftype unary-notation (-> (number) (list-of number)))
(define unary-notation 
  (lambda (n)
    ;; ENSURES: Result is a list of n 1's.
    (cond 
      ((zero? n) '())
      (else (cons 1 (unary-notation (sub1 n)))))))
